Index: trunk/autoquest-core-tasktrees-test/src/test/java/de/ugoe/cs/autoquest/tasktrees/taskequality/GUIEventTaskComparisonRuleTest.java
===================================================================
--- trunk/autoquest-core-tasktrees-test/src/test/java/de/ugoe/cs/autoquest/tasktrees/taskequality/GUIEventTaskComparisonRuleTest.java	(revision 1190)
+++ trunk/autoquest-core-tasktrees-test/src/test/java/de/ugoe/cs/autoquest/tasktrees/taskequality/GUIEventTaskComparisonRuleTest.java	(revision 1294)
@@ -1108,15 +1285,13 @@
     @Test
     public void test_compare_MouseDragAndDrop_07() {
-        ITaskFactory taskFactory = new TaskFactory();
-        
         IEventType eventType1 = new MouseDragAndDrop(1, 2, 3, 4);
         IEventTarget eventTarget1 = new DummyGUIElement("elem1");
-        ITask task1 = taskFactory.createNewEventTask(eventType1, eventTarget1);
+        ITask task1 = createNewEventTask(eventType1, eventTarget1);
         
         IEventType eventType2 = new MouseDragAndDrop(1, 2, 3, 4);
         IEventTarget eventTarget2 = new DummyGUIElement("elem2");
-        ITask task2 = taskFactory.createNewEventTask(eventType2, eventTarget2);
-        
-        assertUnequal(task1, task2);
+        ITask task2 = createNewEventTask(eventType2, eventTarget2);
+        
+        assertUnequal(new GUIEventTaskComparisonRule(), task1, task2);
     }
 
@@ -1126,11 +1301,9 @@
     @Test
     public void test_compare_Scroll_01() {
-        ITaskFactory taskFactory = new TaskFactory();
-        
         IEventType eventType1 = new Scroll(1, 2);
         IEventTarget eventTarget1 = new DummyGUIElement("elem1");
-        ITask task1 = taskFactory.createNewEventTask(eventType1, eventTarget1);
-        
-        assertLexicallyEqual(task1, task1);
+        ITask task1 = createNewEventTask(eventType1, eventTarget1);
+        
+        assertLexicallyEqual(new GUIEventTaskComparisonRule(), task1, task1);
     }
 
@@ -1140,14 +1313,12 @@
     @Test
     public void test_compare_Scroll_02() {
-        ITaskFactory taskFactory = new TaskFactory();
-        
         IEventType eventType1 = new Scroll(1, 2);
         IEventTarget eventTarget1 = new DummyGUIElement("elem1");
-        ITask task1 = taskFactory.createNewEventTask(eventType1, eventTarget1);
+        ITask task1 = createNewEventTask(eventType1, eventTarget1);
         
         IEventType eventType2 = new Scroll(1, 2);
-        ITask task2 = taskFactory.createNewEventTask(eventType2, eventTarget1);
-        
-        assertLexicallyEqual(task1, task2);
+        ITask task2 = createNewEventTask(eventType2, eventTarget1);
+        
+        assertLexicallyEqual(new GUIEventTaskComparisonRule(), task1, task2);
     }
 
@@ -1157,14 +1328,12 @@
     @Test
     public void test_compare_Scroll_03() {
-        ITaskFactory taskFactory = new TaskFactory();
-        
         IEventType eventType1 = new Scroll(1, 2);
         IEventTarget eventTarget1 = new DummyGUIElement("elem1");
-        ITask task1 = taskFactory.createNewEventTask(eventType1, eventTarget1);
+        ITask task1 = createNewEventTask(eventType1, eventTarget1);
         
         IEventType eventType2 = new Scroll(3, 2);
-        ITask task2 = taskFactory.createNewEventTask(eventType2, eventTarget1);
-        
-        assertSemanticallyEqual(task1, task2);
+        ITask task2 = createNewEventTask(eventType2, eventTarget1);
+        
+        assertSemanticallyEqual(new GUIEventTaskComparisonRule(), task1, task2);
     }
 
@@ -1174,14 +1343,12 @@
     @Test
     public void test_compare_Scroll_04() {
-        ITaskFactory taskFactory = new TaskFactory();
-        
         IEventType eventType1 = new Scroll(1, 2);
         IEventTarget eventTarget1 = new DummyGUIElement("elem1");
-        ITask task1 = taskFactory.createNewEventTask(eventType1, eventTarget1);
+        ITask task1 = createNewEventTask(eventType1, eventTarget1);
         
         IEventType eventType2 = new Scroll(1, 3);
-        ITask task2 = taskFactory.createNewEventTask(eventType2, eventTarget1);
-        
-        assertSemanticallyEqual(task1, task2);
+        ITask task2 = createNewEventTask(eventType2, eventTarget1);
+        
+        assertSemanticallyEqual(new GUIEventTaskComparisonRule(), task1, task2);
     }
 
@@ -1191,15 +1358,13 @@
     @Test
     public void test_compare_Scroll_05() {
-        ITaskFactory taskFactory = new TaskFactory();
-        
         IEventType eventType1 = new Scroll(1, 2);
         IEventTarget eventTarget1 = new DummyGUIElement("elem1");
-        ITask task1 = taskFactory.createNewEventTask(eventType1, eventTarget1);
+        ITask task1 = createNewEventTask(eventType1, eventTarget1);
         
         IEventType eventType2 = new Scroll(1, 2);
         IEventTarget eventTarget2 = new DummyGUIElement("elem2");
-        ITask task2 = taskFactory.createNewEventTask(eventType2, eventTarget2);
-        
-        assertUnequal(task1, task2);
+        ITask task2 = createNewEventTask(eventType2, eventTarget2);
+        
+        assertUnequal(new GUIEventTaskComparisonRule(), task1, task2);
     }
     
@@ -1209,6 +1374,4 @@
     @Test
     public void test_compare_TextInput_01() {
-        ITaskFactory taskFactory = new TaskFactory();
-        
         IEventType eventType1 = new StringEventType("eventType1");
         IEventTarget eventTarget1 = new DummyGUIElement("elem1");
@@ -1216,7 +1379,7 @@
         textInputEvents1.add(new Event(eventType1, eventTarget1));
         eventType1 = new TextInput("enteredText1", textInputEvents1);
-        ITask task1 = taskFactory.createNewEventTask(eventType1, eventTarget1);
-        
-        assertLexicallyEqual(task1, task1);
+        ITask task1 = createNewEventTask(eventType1, eventTarget1);
+        
+        assertLexicallyEqual(new GUIEventTaskComparisonRule(), task1, task1);
     }
     
@@ -1226,6 +1389,4 @@
     @Test
     public void test_compare_TextInput_02() {
-        ITaskFactory taskFactory = new TaskFactory();
-        
         IEventType eventType1 = new StringEventType("eventType1");
         IEventTarget eventTarget1 = new DummyGUIElement("elem1");
@@ -1233,10 +1394,10 @@
         textInputEvents1.add(new Event(eventType1, eventTarget1));
         eventType1 = new TextInput("enteredText1", textInputEvents1);
-        ITask task1 = taskFactory.createNewEventTask(eventType1, eventTarget1);
+        ITask task1 = createNewEventTask(eventType1, eventTarget1);
         
         IEventType eventType2 = new TextInput("enteredText1", textInputEvents1);
-        ITask task2 = taskFactory.createNewEventTask(eventType2, eventTarget1);
-
-        assertLexicallyEqual(task1, task2);
+        ITask task2 = createNewEventTask(eventType2, eventTarget1);
+
+        assertLexicallyEqual(new GUIEventTaskComparisonRule(), task1, task2);
     }
     
@@ -1246,6 +1407,4 @@
     @Test
     public void test_compare_TextInput_03() {
-        ITaskFactory taskFactory = new TaskFactory();
-        
         IEventType eventType1 = new StringEventType("eventType1");
         IEventTarget eventTarget1 = new DummyGUIElement("elem1");
@@ -1253,5 +1412,5 @@
         textInputEvents1.add(new Event(eventType1, eventTarget1));
         eventType1 = new TextInput("enteredText1", textInputEvents1);
-        ITask task1 = taskFactory.createNewEventTask(eventType1, eventTarget1);
+        ITask task1 = createNewEventTask(eventType1, eventTarget1);
         
         IEventType eventType2 = new StringEventType("eventType2");
@@ -1259,7 +1418,7 @@
         textInputEvents2.add(new Event(eventType2, eventTarget1));
         eventType2 = new TextInput("enteredText1", textInputEvents2);
-        ITask task2 = taskFactory.createNewEventTask(eventType2, eventTarget1);
-
-        assertSyntacticallyEqual(task1, task2);
+        ITask task2 = createNewEventTask(eventType2, eventTarget1);
+
+        assertSyntacticallyEqual(new GUIEventTaskComparisonRule(), task1, task2);
     }
     
@@ -1269,6 +1428,4 @@
     @Test
     public void test_compare_TextInput_04() {
-        ITaskFactory taskFactory = new TaskFactory();
-        
         IEventType eventType1 = new StringEventType("eventType1");
         IEventTarget eventTarget1 = new DummyGUIElement("elem1");
@@ -1276,5 +1433,5 @@
         textInputEvents1.add(new Event(eventType1, eventTarget1));
         eventType1 = new TextInput("enteredText1", textInputEvents1);
-        ITask task1 = taskFactory.createNewEventTask(eventType1, eventTarget1);
+        ITask task1 = createNewEventTask(eventType1, eventTarget1);
         
         IEventType eventType2 = new StringEventType("eventType2");
@@ -1282,7 +1439,7 @@
         textInputEvents2.add(new Event(eventType2, eventTarget1));
         eventType2 = new TextInput("enteredText2", textInputEvents2);
-        ITask task2 = taskFactory.createNewEventTask(eventType2, eventTarget1);
-
-        assertSemanticallyEqual(task1, task2);
+        ITask task2 = createNewEventTask(eventType2, eventTarget1);
+
+        assertSemanticallyEqual(new GUIEventTaskComparisonRule(), task1, task2);
     }
     
@@ -1292,6 +1449,4 @@
     @Test
     public void test_compare_TextInput_05() {
-        ITaskFactory taskFactory = new TaskFactory();
-        
         IEventType eventType1 = new StringEventType("eventType1");
         IEventTarget eventTarget1 = new DummyGUIElement("elem1");
@@ -1299,10 +1454,10 @@
         textInputEvents1.add(new Event(eventType1, eventTarget1));
         eventType1 = new TextInput("enteredText1", textInputEvents1);
-        ITask task1 = taskFactory.createNewEventTask(eventType1, eventTarget1);
-        
-        IEventTarget eventTarget2 = new DummyGUIElement("elem2");
-        ITask task2 = taskFactory.createNewEventTask(eventType1, eventTarget2);
-
-        assertUnequal(task1, task2);
+        ITask task1 = createNewEventTask(eventType1, eventTarget1);
+        
+        IEventTarget eventTarget2 = new DummyGUIElement("elem2");
+        ITask task2 = createNewEventTask(eventType1, eventTarget2);
+
+        assertUnequal(new GUIEventTaskComparisonRule(), task1, task2);
     }
 
@@ -1312,11 +1467,9 @@
     @Test
     public void test_compare_TextSelection_01() {
-        ITaskFactory taskFactory = new TaskFactory();
-        
         IEventType eventType1 = new TextSelection();
         IEventTarget eventTarget1 = new DummyGUIElement("elem1");
-        ITask task1 = taskFactory.createNewEventTask(eventType1, eventTarget1);
-        
-        assertLexicallyEqual(task1, task1);
+        ITask task1 = createNewEventTask(eventType1, eventTarget1);
+        
+        assertLexicallyEqual(new GUIEventTaskComparisonRule(), task1, task1);
     }
 
@@ -1326,14 +1479,12 @@
     @Test
     public void test_compare_TextSelection_02() {
-        ITaskFactory taskFactory = new TaskFactory();
-        
         IEventType eventType1 = new TextSelection();
         IEventTarget eventTarget1 = new DummyGUIElement("elem1");
-        ITask task1 = taskFactory.createNewEventTask(eventType1, eventTarget1);
+        ITask task1 = createNewEventTask(eventType1, eventTarget1);
 
         IEventType eventType2 = new TextSelection();
-        ITask task2 = taskFactory.createNewEventTask(eventType2, eventTarget1);
-        
-        assertLexicallyEqual(task1, task2);
+        ITask task2 = createNewEventTask(eventType2, eventTarget1);
+        
+        assertLexicallyEqual(new GUIEventTaskComparisonRule(), task1, task2);
     }
 
@@ -1343,15 +1494,13 @@
     @Test
     public void test_compare_TextSelection_03() {
-        ITaskFactory taskFactory = new TaskFactory();
-        
         IEventType eventType1 = new TextSelection();
         IEventTarget eventTarget1 = new DummyGUIElement("elem1");
-        ITask task1 = taskFactory.createNewEventTask(eventType1, eventTarget1);
+        ITask task1 = createNewEventTask(eventType1, eventTarget1);
 
         IEventType eventType2 = new TextSelection();
         IEventTarget eventTarget2 = new DummyGUIElement("elem2");
-        ITask task2 = taskFactory.createNewEventTask(eventType2, eventTarget2);
-        
-        assertUnequal(task1, task2);
+        ITask task2 = createNewEventTask(eventType2, eventTarget2);
+        
+        assertUnequal(new GUIEventTaskComparisonRule(), task1, task2);
     }
 
@@ -1361,11 +1510,9 @@
     @Test
     public void test_compare_ValueSelection_01() {
-        ITaskFactory taskFactory = new TaskFactory();
-        
         IEventType eventType1 = new ValueSelection<String>("value1");
         IEventTarget eventTarget1 = new DummyGUIElement("elem1");
-        ITask task1 = taskFactory.createNewEventTask(eventType1, eventTarget1);
-        
-        assertLexicallyEqual(task1, task1);
+        ITask task1 = createNewEventTask(eventType1, eventTarget1);
+        
+        assertLexicallyEqual(new GUIEventTaskComparisonRule(), task1, task1);
     }
 
@@ -1375,14 +1522,12 @@
     @Test
     public void test_compare_ValueSelection_02() {
-        ITaskFactory taskFactory = new TaskFactory();
-        
         IEventType eventType1 = new ValueSelection<String>("value1");
         IEventTarget eventTarget1 = new DummyGUIElement("elem1");
-        ITask task1 = taskFactory.createNewEventTask(eventType1, eventTarget1);
+        ITask task1 = createNewEventTask(eventType1, eventTarget1);
         
         IEventType eventType2 = new ValueSelection<String>("value1");
-        ITask task2 = taskFactory.createNewEventTask(eventType2, eventTarget1);
-        
-        assertLexicallyEqual(task1, task2);
+        ITask task2 = createNewEventTask(eventType2, eventTarget1);
+        
+        assertLexicallyEqual(new GUIEventTaskComparisonRule(), task1, task2);
     }
 
@@ -1392,14 +1537,12 @@
     @Test
     public void test_compare_ValueSelection_03() {
-        ITaskFactory taskFactory = new TaskFactory();
-        
         IEventType eventType1 = new ValueSelection<String>("value1");
         IEventTarget eventTarget1 = new DummyGUIElement("elem1");
-        ITask task1 = taskFactory.createNewEventTask(eventType1, eventTarget1);
+        ITask task1 = createNewEventTask(eventType1, eventTarget1);
         
         IEventType eventType2 = new ValueSelection<String>("value2");
-        ITask task2 = taskFactory.createNewEventTask(eventType2, eventTarget1);
-        
-        assertSemanticallyEqual(task1, task2);
+        ITask task2 = createNewEventTask(eventType2, eventTarget1);
+        
+        assertSemanticallyEqual(new GUIEventTaskComparisonRule(), task1, task2);
     }
 
@@ -1409,83 +1552,13 @@
     @Test
     public void test_compare_ValueSelection_04() {
-        ITaskFactory taskFactory = new TaskFactory();
-        
         IEventType eventType1 = new ValueSelection<String>("value1");
         IEventTarget eventTarget1 = new DummyGUIElement("elem1");
-        ITask task1 = taskFactory.createNewEventTask(eventType1, eventTarget1);
+        ITask task1 = createNewEventTask(eventType1, eventTarget1);
         
         IEventType eventType2 = new ValueSelection<String>("value1");
         IEventTarget eventTarget2 = new DummyGUIElement("elem2");
-        ITask task2 = taskFactory.createNewEventTask(eventType2, eventTarget2);
-        
-        assertUnequal(task1, task2);
-    }
-    
-    /**
-     *
-     */
-    private void assertLexicallyEqual(ITask task1, ITask task2) {
-        GUIEventTaskComparisonRule rule = new GUIEventTaskComparisonRule();
-        
-        assertEquals(TaskEquality.LEXICALLY_EQUAL, rule.compare(task1, task2));
-        assertTrue(rule.areLexicallyEqual(task1, task2));
-        assertTrue(rule.areSyntacticallyEqual(task1, task2));
-        assertTrue(rule.areSemanticallyEqual(task1, task2));
-
-        assertEquals(TaskEquality.LEXICALLY_EQUAL, rule.compare(task2, task1));
-        assertTrue(rule.areLexicallyEqual(task2, task1));
-        assertTrue(rule.areSyntacticallyEqual(task2, task1));
-        assertTrue(rule.areSemanticallyEqual(task2, task1));
-    }
-
-    /**
-     *
-     */
-    private void assertSyntacticallyEqual(ITask task1, ITask task2) {
-        GUIEventTaskComparisonRule rule = new GUIEventTaskComparisonRule();
-        
-        assertEquals(TaskEquality.SYNTACTICALLY_EQUAL, rule.compare(task1, task2));
-        assertFalse(rule.areLexicallyEqual(task1, task2));
-        assertTrue(rule.areSyntacticallyEqual(task1, task2));
-        assertTrue(rule.areSemanticallyEqual(task1, task2));
-
-        assertEquals(TaskEquality.SYNTACTICALLY_EQUAL, rule.compare(task2, task1));
-        assertFalse(rule.areLexicallyEqual(task2, task1));
-        assertTrue(rule.areSyntacticallyEqual(task2, task1));
-        assertTrue(rule.areSemanticallyEqual(task2, task1));
-    }
-
-    /**
-     *
-     */
-    private void assertSemanticallyEqual(ITask task1, ITask task2) {
-        GUIEventTaskComparisonRule rule = new GUIEventTaskComparisonRule();
-        
-        assertEquals(TaskEquality.SEMANTICALLY_EQUAL, rule.compare(task1, task2));
-        assertFalse(rule.areLexicallyEqual(task1, task2));
-        assertFalse(rule.areSyntacticallyEqual(task1, task2));
-        assertTrue(rule.areSemanticallyEqual(task1, task2));
-
-        assertEquals(TaskEquality.SEMANTICALLY_EQUAL, rule.compare(task2, task1));
-        assertFalse(rule.areLexicallyEqual(task2, task1));
-        assertFalse(rule.areSyntacticallyEqual(task2, task1));
-        assertTrue(rule.areSemanticallyEqual(task2, task1));
-    }
-
-    /**
-     *
-     */
-    private void assertUnequal(ITask task1, ITask task2) {
-        GUIEventTaskComparisonRule rule = new GUIEventTaskComparisonRule();
-        
-        assertEquals(TaskEquality.UNEQUAL, rule.compare(task1, task2));
-        assertFalse(rule.areLexicallyEqual(task1, task2));
-        assertFalse(rule.areSyntacticallyEqual(task1, task2));
-        assertFalse(rule.areSemanticallyEqual(task1, task2));
-
-        assertEquals(TaskEquality.UNEQUAL, rule.compare(task2, task1));
-        assertFalse(rule.areLexicallyEqual(task2, task1));
-        assertFalse(rule.areSyntacticallyEqual(task2, task1));
-        assertFalse(rule.areSemanticallyEqual(task2, task1));
+        ITask task2 = createNewEventTask(eventType2, eventTarget2);
+        
+        assertUnequal(new GUIEventTaskComparisonRule(), task1, task2);
     }
 }
Index: trunk/autoquest-core-tasktrees-test/src/test/java/de/ugoe/cs/autoquest/tasktrees/taskequality/IterationComparisonRuleTest.java
===================================================================
--- trunk/autoquest-core-tasktrees-test/src/test/java/de/ugoe/cs/autoquest/tasktrees/taskequality/IterationComparisonRuleTest.java	(revision 1190)
+++ trunk/autoquest-core-tasktrees-test/src/test/java/de/ugoe/cs/autoquest/tasktrees/taskequality/IterationComparisonRuleTest.java	(revision 1294)
@@ -23,12 +23,7 @@
 import de.ugoe.cs.autoquest.eventcore.StringEventType;
 import de.ugoe.cs.autoquest.tasktrees.taskequality.IterationComparisonRule;
-import de.ugoe.cs.autoquest.tasktrees.taskequality.TaskEquality;
 import de.ugoe.cs.autoquest.tasktrees.treeifc.IIteration;
 import de.ugoe.cs.autoquest.tasktrees.treeifc.ISelection;
-import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskBuilder;
 import de.ugoe.cs.autoquest.tasktrees.treeifc.ITask;
-import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskFactory;
-import de.ugoe.cs.autoquest.tasktrees.treeimpl.TaskBuilder;
-import de.ugoe.cs.autoquest.tasktrees.treeimpl.TaskFactory;
 import de.ugoe.cs.autoquest.test.DummyGUIElement;
 
@@ -36,14 +31,162 @@
  * @author Patrick Harms
  */
-public class IterationComparisonRuleTest {
-
-    /**
-     *
-     */
-    @Test
-    public void test() {
-        ITaskFactory taskFactory = new TaskFactory();
-        ITaskBuilder treeBuilder = new TaskBuilder();
-        
+public class IterationComparisonRuleTest extends AbstractComparisonRuleTest {
+
+    /**
+     *
+     */
+    @Test
+    public void test_isApplicable_01() {
+        IterationComparisonRule rule = new IterationComparisonRule();
+        
+        ITask task1 = createNewIteration();
+        
+        assertTrue(rule.isApplicable(task1, task1));
+    }
+
+    /**
+     *
+     */
+    @Test
+    public void test_isApplicable_02() {
+        IterationComparisonRule rule = new IterationComparisonRule();
+
+        ITask task1 = createNewIteration();
+        ITask task2 = createNewIteration();
+        
+        assertTrue(rule.isApplicable(task1, task2));
+        assertTrue(rule.isApplicable(task2, task1));
+    }
+
+    /**
+     *
+     */
+    @Test
+    public void test_isApplicable_03() {
+        IterationComparisonRule rule = new IterationComparisonRule();
+
+        ITask task1 = createNewIteration();
+        ITask task2 = createNewSequence();
+        
+        assertFalse(rule.isApplicable(task1, task2));
+        assertFalse(rule.isApplicable(task2, task1));
+    }
+
+    /**
+     *
+     */
+    @Test
+    public void test_isApplicable_04() {
+        IterationComparisonRule rule = new IterationComparisonRule();
+
+        ITask task1 = createNewIteration();
+        ITask task2 = createNewSelection();
+        
+        assertFalse(rule.isApplicable(task1, task2));
+        assertFalse(rule.isApplicable(task2, task1));
+    }
+
+    /**
+     *
+     */
+    @Test
+    public void test_isApplicable_05() {
+        IterationComparisonRule rule = new IterationComparisonRule();
+
+        ITask task1 = createNewIteration();
+        ITask task2 = createNewOptional();
+        
+        assertFalse(rule.isApplicable(task1, task2));
+        assertFalse(rule.isApplicable(task2, task1));
+    }
+
+    /**
+     *
+     */
+    @Test
+    public void test_isApplicable_06() {
+        IterationComparisonRule rule = new IterationComparisonRule();
+        
+        IEventType eventType1 = new StringEventType("eventType1");
+        IEventTarget eventTarget1 = new DummyGUIElement("elem1");
+
+        ITask task1 = createNewIteration();
+        ITask task2 = createNewEventTask(eventType1, eventTarget1);
+        
+        assertFalse(rule.isApplicable(task1, task2));
+        assertFalse(rule.isApplicable(task2, task1));
+    }
+
+    /**
+     *
+     */
+    @Test
+    public void test_compare_01() {
+        IterationComparisonRule rule = new IterationComparisonRule();
+        
+        IIteration iteration1 = createNewIteration();
+        
+        assertLexicallyEqual(rule, iteration1, iteration1);
+    }
+
+    /**
+     *
+     */
+    @Test
+    public void test_compare_02() {
+        IterationComparisonRule rule = new IterationComparisonRule();
+        
+        IIteration iteration1 = createNewIteration();
+        IIteration iteration2 = createNewIteration();
+        
+        assertLexicallyEqual(rule, iteration1, iteration2);
+    }
+
+    /**
+     *
+     */
+    @Test
+    public void test_compare_03() {
+        IterationComparisonRule rule = new IterationComparisonRule();
+        
+        IEventType eventType1 = new StringEventType("eventType1");
+        IEventTarget eventTarget1 = new DummyGUIElement("elem1");
+
+        ITask task1 = createNewEventTask(eventType1, eventTarget1);
+        
+        IIteration iteration1 = createNewIteration();
+        IIteration iteration2 = createNewIteration();
+        
+        setMarkedTask(iteration1, task1);
+        
+        assertUnequal(rule, iteration1, iteration2);
+    }
+
+    /**
+     *
+     */
+    @Test
+    public void test_compare_04() {
+        IterationComparisonRule rule = new IterationComparisonRule();
+        
+        IEventType eventType1 = new StringEventType("eventType1");
+        IEventTarget eventTarget1 = new DummyGUIElement("elem1");
+
+        ITask task1 = createNewEventTask(eventType1, eventTarget1);
+        
+        IIteration iteration1 = createNewIteration();
+        IIteration iteration2 = createNewIteration();
+        
+        setMarkedTask(iteration1, task1);
+        setMarkedTask(iteration2, task1);
+        
+        assertLexicallyEqual(rule, iteration1, iteration2);
+    }
+
+    /**
+     *
+     */
+    @Test
+    public void test_compare_05() {
         IterationComparisonRule rule = new IterationComparisonRule();
         
@@ -54,60 +197,95 @@
         IEventTarget eventTarget2 = new DummyGUIElement("elem2");
 
-        ITask task1 = taskFactory.createNewEventTask(eventType1, eventTarget1);
-        ITask task2 = taskFactory.createNewEventTask(eventType2, eventTarget2);
-        
-        assertFalse(rule.isApplicable(task1, task2));
-        
-        IIteration iteration1 = taskFactory.createNewIteration();
-        assertEquals(TaskEquality.LEXICALLY_EQUAL, rule.compare(iteration1, iteration1));
-
-        IIteration iteration2 = taskFactory.createNewIteration();
-        
-        assertEquals(TaskEquality.LEXICALLY_EQUAL, rule.compare(iteration1, iteration2));
-        assertEquals(TaskEquality.LEXICALLY_EQUAL, rule.compare(iteration2, iteration1));
-        
-        treeBuilder.setMarkedTask(iteration1, task1);
-        
-        assertEquals(TaskEquality.UNEQUAL, rule.compare(iteration1, iteration2));
-        assertEquals(TaskEquality.UNEQUAL, rule.compare(iteration2, iteration1));
-        
-        treeBuilder.setMarkedTask(iteration2, task1);
-        
-        assertEquals(TaskEquality.LEXICALLY_EQUAL, rule.compare(iteration1, iteration2));
-        assertEquals(TaskEquality.LEXICALLY_EQUAL, rule.compare(iteration2, iteration1));
-        
-        treeBuilder.setMarkedTask(iteration1, task2);
-        
-        assertEquals(TaskEquality.UNEQUAL, rule.compare(iteration1, iteration2));
-        assertEquals(TaskEquality.UNEQUAL, rule.compare(iteration2, iteration1));
-        
-        treeBuilder.setMarkedTask(iteration2, task2);
-        
-        assertEquals(TaskEquality.LEXICALLY_EQUAL, rule.compare(iteration1, iteration2));
-        assertEquals(TaskEquality.LEXICALLY_EQUAL, rule.compare(iteration2, iteration1));
-        
-        ISelection selection1 = taskFactory.createNewSelection();
-        treeBuilder.addChild(selection1, task2);
-        treeBuilder.setMarkedTask(iteration1, selection1);
-        
-        assertEquals(TaskEquality.LEXICALLY_EQUAL, rule.compare(iteration1, iteration2));
-        assertEquals(TaskEquality.LEXICALLY_EQUAL, rule.compare(iteration2, iteration1));
-        
-        ISelection selection2 = taskFactory.createNewSelection();
-        treeBuilder.addChild(selection2, task2);
-        treeBuilder.setMarkedTask(iteration2, selection2);
-        
-        assertEquals(TaskEquality.LEXICALLY_EQUAL, rule.compare(iteration1, iteration2));
-        assertEquals(TaskEquality.LEXICALLY_EQUAL, rule.compare(iteration2, iteration1));
-        
-        assertFalse(rule.isApplicable(iteration1, selection1));
-        assertFalse(rule.isApplicable(selection1, iteration1));
-        assertFalse(rule.isApplicable(iteration2, selection1));
-        assertFalse(rule.isApplicable(selection1, iteration2));
-
-        assertFalse(rule.isApplicable(iteration1, selection2));
-        assertFalse(rule.isApplicable(selection2, iteration1));
-        assertFalse(rule.isApplicable(iteration2, selection2));
-        assertFalse(rule.isApplicable(selection2, iteration2));
+        ITask task1 = createNewEventTask(eventType1, eventTarget1);
+        ITask task2 = createNewEventTask(eventType2, eventTarget2);
+        
+        IIteration iteration1 = createNewIteration();
+        IIteration iteration2 = createNewIteration();
+        
+        setMarkedTask(iteration1, task1);
+        setMarkedTask(iteration1, task2);
+        
+        assertUnequal(rule, iteration1, iteration2);
+    }
+
+    /**
+     *
+     */
+    @Test
+    public void test_compare_06() {
+        IterationComparisonRule rule = new IterationComparisonRule();
+        
+        IEventType eventType1 = new StringEventType("eventType1");
+        IEventTarget eventTarget1 = new DummyGUIElement("elem1");
+
+        ITask task1 = createNewEventTask(eventType1, eventTarget1);
+        
+        IIteration iteration1 = createNewIteration();
+        IIteration iteration2 = createNewIteration();
+        
+        ISelection selection1 = createNewSelection();
+        addChild(selection1, task1);
+        setMarkedTask(iteration1, selection1);
+        
+        setMarkedTask(iteration2, task1);
+        
+        assertLexicallyEqual(rule, iteration1, iteration2);
+    }
+
+    /**
+     *
+     */
+    @Test
+    public void test_compare_07() {
+        IterationComparisonRule rule = new IterationComparisonRule();
+        
+        IEventType eventType1 = new StringEventType("eventType1");
+        IEventTarget eventTarget1 = new DummyGUIElement("elem1");
+
+        ITask task1 = createNewEventTask(eventType1, eventTarget1);
+        
+        IIteration iteration1 = createNewIteration();
+        IIteration iteration2 = createNewIteration();
+        
+        ISelection selection1 = createNewSelection();
+        addChild(selection1, task1);
+        setMarkedTask(iteration1, selection1);
+        
+        ISelection selection2 = createNewSelection();
+        addChild(selection2, task1);
+        setMarkedTask(iteration2, selection2);
+        
+        assertLexicallyEqual(rule, iteration1, iteration2);
+    }
+
+    /**
+     *
+     */
+    @Test
+    public void test_compare_08() {
+        IterationComparisonRule rule = new IterationComparisonRule();
+        
+        IEventType eventType1 = new StringEventType("eventType1");
+        IEventTarget eventTarget1 = new DummyGUIElement("elem1");
+
+        IEventType eventType2 = new StringEventType("eventType2");
+        IEventTarget eventTarget2 = new DummyGUIElement("elem2");
+
+        ITask task1 = createNewEventTask(eventType1, eventTarget1);
+        ITask task2 = createNewEventTask(eventType2, eventTarget2);
+        
+        IIteration iteration1 = createNewIteration();
+        IIteration iteration2 = createNewIteration();
+        
+        ISelection selection1 = createNewSelection();
+        addChild(selection1, task1);
+        addChild(selection1, task2);
+        setMarkedTask(iteration1, selection1);
+
+        ISelection selection2 = createNewSelection();
+        addChild(selection2, task2);
+        setMarkedTask(iteration2, selection2);
+        
+        assertLexicallyEqual(rule, iteration1, iteration2);
     }
 
